# List top contributors

URL: https://docs.hanzo.ai/docs/openapi/o11y/getrulehistorytopcontributors

> Returns the label combinations that contributed most to a rule firing over the selected range.

`GET /v1/o11y/rules/{id}/history/top_contributors`

> [O11y →](https://docs.hanzo.ai/docs/openapi/o11y) · [All API references →](https://docs.hanzo.ai/docs/openapi) · [Get started →](https://docs.hanzo.ai/docs/guides)

|               |                                                                    |
| ------------- | ------------------------------------------------------------------ |
| **Address**   | `https://api.hanzo.ai/v1/o11y/rules/{id}/history/top_contributors` |
| **Method**    | `GET`                                                              |
| **Operation** | `GetRuleHistoryTopContributors`                                    |
| **Auth**      | `Authorization: Bearer $HANZO_API_KEY`                             |

Returns the label combinations that contributed
most to a rule firing over the selected range. Viewer gate.

## Request

3 fields.

| Field   | In    | Type    | Required | Description                                   |
| ------- | ----- | ------- | -------- | --------------------------------------------- |
| `id`    | path  | string  | yes      |                                               |
| `start` | query | integer | —        | Start is the window start, unix milliseconds. |
| `end`   | query | integer | —        | End is the window end, unix milliseconds.     |

## Response

| Status    | Body                                | Meaning           |
| --------- | ----------------------------------- | ----------------- |
| `200`     | o11y.O11yRuleHistoryContributorsOut | ok                |
| `202`     | Approval                            | held for approval |
| `default` | problem-details                     | refused           |

`200` body — 15 fields.

| Field                               | In   | Type                                        | Always | Description                  |
| ----------------------------------- | ---- | ------------------------------------------- | ------ | ---------------------------- |
| `data`                              | body | o11y.GettableRuleStateHistoryContributor\[] | —      | Data holds the contributors. |
| `data[].count`                      | body | integer (uint64)                            | —      |                              |
| `data[].fingerprint`                | body | integer (uint64)                            | —      |                              |
| `data[].labels`                     | body | o11y.Label\[]                               | —      |                              |
| `data[].labels[].key`               | body | o11y.TelemetryFieldKey                      | —      |                              |
| `data[].labels[].key.description`   | body | string                                      | —      |                              |
| `data[].labels[].key.fieldContext`  | body | any                                         | —      |                              |
| `data[].labels[].key.fieldDataType` | body | any                                         | —      |                              |
| `data[].labels[].key.name`          | body | string                                      | yes    |                              |
| `data[].labels[].key.signal`        | body | any                                         | —      |                              |
| `data[].labels[].key.unit`          | body | string                                      | —      |                              |
| `data[].labels[].value`             | body | any                                         | —      |                              |
| `data[].relatedLogsLink`            | body | string                                      | —      |                              |
| `data[].relatedTracesLink`          | body | string                                      | —      |                              |
| `status`                            | body | string                                      | —      | Status is "success".         |

Failure carries the platform error shape — see [Errors](https://docs.hanzo.ai/docs/errors).

## Examples

**CLI**

```bash
hanzo o11y rules history top_contributors get <id>
```

**SDK**

**.ts**

```ts
import { Configuration, O11yApi } from 'hanzoai';

const api = new O11yApi(new Configuration({ accessToken: process.env.HANZO_API_KEY }));
const { data } = await api.getRuleHistoryTopContributors({ id: 'id' });
```

**.py**

```python
from hanzoai.cloud import ApiClient, Configuration
from hanzoai.cloud.api import O11yApi

client = ApiClient(Configuration(access_token=os.environ["HANZO_API_KEY"]))
result = O11yApi(client).get_rule_history_top_contributors(id='id')
```

**.go**

```go
cfg := hanzoai.NewConfiguration()
cfg.AddDefaultHeader("Authorization", "Bearer "+os.Getenv("HANZO_API_KEY"))
client := hanzoai.NewAPIClient(cfg)

resp, _, err := client.O11yAPI.GetRuleHistoryTopContributors(context.Background()).Execute()
if err != nil {
	return err
}
```

**.rs**

```rust
use hanzo_client::apis::{configuration::Configuration, o11y_api};

let mut cfg = Configuration::new();
cfg.bearer_access_token = std::env::var("HANZO_API_KEY").ok();

let result = o11y_api::get_rule_history_top_contributors(&cfg, Default::default()).await?;
```

**.java**

```java
import ai.hanzo.cloud.ApiClient;
import ai.hanzo.cloud.api.O11yApi;

ApiClient client = new ApiClient();
client.setBearerToken(System.getenv("HANZO_API_KEY"));

var result = new O11yApi(client).getRuleHistoryTopContributors();
```

**HTTP**

```bash
curl https://api.hanzo.ai/v1/o11y/rules/<id>/history/top_contributors \
  -H "Authorization: Bearer $HANZO_API_KEY"
```

**MCP**

Tool `o11y`, op `GetRuleHistoryTopContributors` — POST the JSON-RPC envelope to `https://api.hanzo.ai/v1/mcp`.

```bash
curl -X POST https://api.hanzo.ai/v1/mcp \
  -H "Authorization: Bearer $HANZO_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
       "jsonrpc": "2.0",
       "id": 1,
       "method": "tools/call",
       "params": {
         "name": "o11y",
         "arguments": {
           "op": "GetRuleHistoryTopContributors",
           "input": {
             "id": "<id>"
           }
         }
       }
     }'
```

---

[O11y API](https://docs.hanzo.ai/docs/openapi/o11y) · [All Hanzo APIs](https://docs.hanzo.ai/docs/openapi) · [Interactive reference](https://docs.hanzo.ai/docs/openapi/reference)
